/*   
copyright: Steve Dekorte, 2004. All rights reserved.
license: See _BSDLicense.txt.

object: Host
prototype: Object

module: IoServer
description: The Host object is usefull for doing DNS lookups on host names.
<pre>
  ipForYahoo := Host clone setName("yahoo.com") address
</pre>
*/

Host := Object clone do(
    type := "Host"

    /*
    method: setName(aString)
    description: Set's the host name. Return self. 
    */
    /*
    method: name
    description: Returns name. 
    */
    newSlot("name")

    /*
    method: address
    description: Returns the ip address. A DNS lookup is done in the background if the address is not already known. Raises an exception on lookup  error.
    */

    newSlot("address")
    ip := nil

    address := method(
        if (name size == 0, Exception raise("attempt to lookup empty hostname"))
        ip = DNSResolver ipForHostName(name)
        if(ip == false, Exception raise("ip lookup for hostname '" .. name .. "' failed"))
        self address = ip
    )
)


