/*   
copyright: Steve Dekorte, 2004. All rights reserved.
license: See _BSDLicense.txt.

object: DOServer
prototype: Server

module: IoServer
description: The DOServer object is usefull for fetching web pages and parsing DOServers. Example;
<pre>
Test := Object clone
Test test := method(v, write("got test '", v, "'\n"); return List clone append(1))

doServer := DOServer clone
doServer setRootObject(Test clone)
doServer setPort(8456)
doServer start
</pre>
*/

DOServer := Server clone do(
    type := "DOServer"
    
    /*
    method: setRootObject(anObject)
    description: Sets the root object which incoming messages will be send to.
    */
    
    setRootObject := method(obj, self rootObject := obj; self)
    handleSocket := method(aSocket,
	con := DOConnection clone 
	con localObjects atPut("0", rootObject)
	con @handleSocket(aSocket)
    )
)