
Protos CLI := Object clone do(
	type := "CLI"
	stdout := File clone standardOutput
	stdin  := File clone standardInput
	inPrompt  := "Io> "
	outPrompt := "==> "
	multiLine := true

	runPath := method(path,
		Lobby launchPath := Directory currentWorkingDirectory asMutable appendPathSeq(path pathComponent)
		result := 0
		e := try(result = Lobby doFile(path))
		if(e, e showStack)
		if(getSlot("result") type != "Number", result = 0)
		System exit(result)
	)

	run := method(
		if(?args and(args size > 0), 
			path := if (args first == "-i", args at(1), args first)
			if (path, self runPath(path))
		)

		writeln(System distribution, " ", System version)

		Lobby launchPath := Directory currentWorkingDirectory
        Lobby exit := method(System exit)
        interactiveMultiline
	)
	
	interactive := method(
		loop(
			write(inPrompt)
			line := stdin readLine
			line ifNil(Lobby exit)
			result := nil
			e := try(result = Lobby doString(line))
			if(e, e showStack)
			writeln(outPrompt, getSlot("result"))
		)
	)
	
	interactiveMultiline := method(
		errTriQuote := try( Compiler messageForString("\"\"\"") ) error
		errParen    := try( Compiler messageForString("(") ) error
		errArg      := try( Compiler messageForString("(x,") ) error
		listContinueOnErr := list( errTriQuote, errParen )

  		loop(
  			write(inPrompt)
			line := ""
			loop( 
				line := line .. "\n" .. (stdin readLine ifNil(Lobby exit))
				if( line endsWithSeq("\\"), continue )
				result := nil
				e := try(result = Lobby doString(line))
				if(e,
					err := e error
					if(self multiLine and(
						  listContinueOnErr contains(err) or(
						  err ==(errArg) and(line asMutable strip endsWithSeq(",")) ) ),
						continue
					)
					e showStack
				)
				break
			)
			writeln("\n", outPrompt, getSlot("result"))
		)
	)
)
